## stress-ng-0.18.01.tar.gz

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2024 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

#
# Codename "synchronized synthetic stressor"
#
VERSION=0.18.01

#
# Determine supported toolchains
#
COMPILER = cc
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep gcc),)
COMPILER = gcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep icc),)
COMPILER = icc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "Portable C Compiler"),)
COMPILER = pcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "tcc"),)
COMPILER = tcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep clang),)
COMPILER = clang
endif
ifneq ($(shell $(CC) -v 2>&1 | grep oneAPI | grep Compiler),)
COMPILER = icx
endif
ifneq ($(shell $(CC) -v 2>&1 | grep scan-build),)
COMPILER = scan-build
endif
ifneq ($(basename $(CC) | grep ccc-analyzer),)
COMPILER = scan-build
endif

KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)

override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99

#
#  Building stress-vnni with less than -O2 causes breakage with
#  gcc-13.2, so remove then and ensure at least -O2 is used or
#  honour flags > -O2 if they are provided
#
VNNI_OFLAGS_REMOVE=-O0 -O1 -Os -Oz -Og
VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))

#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	override CFLAGS += -O2
endif
ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
	override VNNI_CFLAGS += -O2
endif

#
# Debug flag
#
ifeq ($(DEBUG),1)
override CFLAGS += -g
endif

#
# Check if compiler supports flag set in $(flag)
#
cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)

PEDANTIC_FLAGS := \
	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE = $(shell uname -m)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
flag = -Wformat -fstack-protector-strong \
	-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 \
	-Werror=format-security
override CFLAGS += $(cc_supports_flag)
endif
endif

#
# Optimization flags
#
ifneq ($(filter-out clang icc scan-build,$(COMPILER)),)
override CFLAGS += $(foreach flag,-fipa-pta,$(cc_supports_flag))
endif
#
# Enable Link Time Optimization
#
ifeq ($(LTO),1)
override CFLAGS += $(foreach flag,-flto=auto,$(cc_supports_flag))
endif

ifeq ($(GARBAGE_COLLECT),1)
#
# Sections flags
#
SECTIONS_FLAGS := -ffunction-sections -fdata-sections -Wl,--gc-sections
override CFLAGS += $(foreach flag,$(SECTIONS_FLAGS),$(cc_supports_flag))

ifneq ($(VERBOSE),)
GC_SECTIONS_FLAGS := -Wl,--print-gc-sections
override CFLAGS += $(foreach flag,$(GC_SECTIONS_FLAGS),$(cc_supports_flag))
endif
endif

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
override CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Building with Coverity?
#
ifeq ($(COVERITY),1)
override CFLAGS += -DCOVERITY
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(COMPILER)),icc)
override CFLAGS += -no-inline-max-size -no-inline-max-total-size
override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(COMPILER)),clang)
#override CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
override LDFLAGS += -static -z muldefs
override CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions

#
# Header files
#
HEADERS = \
	core-arch.h \
	core-affinity.h \
	core-asm-arm.h \
	core-asm-generic.h \
	core-asm-loong64.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-asm-ret.h \
	core-attribute.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-clocksource.h \
	core-config-check.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-cpuidle.h \
	core-ftrace.h \
	core-hash.h \
	core-ignite-cpu.h \
	core-interrupts.h \
	core-io-priority.h \
	core-job.h \
	core-helper.h \
	core-killpid.h \
	core-klog.h \
	core-limit.h \
	core-lock.h \
	core-log.h \
	core-madvise.h \
	core-mlock.h \
	core-mmap.h \
	core-mincore.h \
	core-module.h \
	core-mounts.h \
	core-mwc.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-numa.h \
	core-opts.h \
	core-out-of-memory.h \
	core-parse-opts.h \
	core-perf.h \
	core-pragma.h \
	core-processes.h \
	core-pthread.h \
	core-put.h \
	core-resources.h \
	core-sched.h \
	core-setting.h \
	core-shared-heap.h \
	core-shim.h \
	core-smart.h \
	core-sort.h \
	core-stressors.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-time.h \
	core-try-open.h \
	core-vecmath.h \
	core-version.h \
	core-vmstat.h \
	stress-af-alg-defconfigs.h \
	stress-eigen-ops.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-acl.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-besselmath.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-bitonicsort.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-cgroup.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-eigen.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-expmath.c \
	stress-factor.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fd-fork.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fma.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fractal.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \
	stress-handle.c \
	stress-hash.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-insertionsort.c \
	stress-io.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-jpeg.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-kvm.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-led.c \
	stress-link.c \
	stress-list.c \
	stress-llc-affinity.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-logmath.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-lsm.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-metamix.c \
	stress-mincore.c \
	stress-min-nanosleep.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfiles.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-module.c \
	stress-monte-carlo.c \
	stress-mprotect.c \
	stress-mpfr.c \
	stress-mq.c \
	stress-mremap.c \
	stress-mseal.c \
	stress-msg.c \
	stress-msync.c \
	stress-msyncmany.c \
	stress-mtx.c \
	stress-munmap.c \
	stress-mutex.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pagemove.c \
	stress-pageswap.c \
	stress-pci.c \
	stress-personality.c \
	stress-peterson.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-plugin.c \
	stress-poll.c \
	stress-powmath.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-prime.c \
	stress-prio-inv.c \
	stress-priv-instr.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-race-sched.c \
	stress-radixsort.c \
	stress-randlist.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-regs.c \
	stress-remap.c \
	stress-rename.c \
	stress-resched.c \
	stress-resources.c \
	stress-revio.c \
	stress-ring-pipe.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rotate.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedmix.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigbus.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-sigxcpu.c \
	stress-sigxfsz.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-sparsematrix.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-statmount.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-syncload.c \
	stress-sysbadaddr.c \
	stress-syscall.c \

=== debian/changelog ===
stress-ng (0.18.01-1) unstable; urgency=medium

  [Daniel Andriesse]
  * stress-vecwide: fix verify option by setting results vector res

  [Po-Hsu Lin]
  * stress-cache: check RISCV_HWPROBE_EXT_ZICBOZ support for
    stress_cache_bzero

  [Sergey Matyukevich]
  * mmapfork: add --mmapfork-bytes option to specify mmap size

  [Colin Ian King]
  * Makefile: bump version
  * stress-ng: cast s_pids to void * in munmap to clear up OpenHipster
    build warning
  * stress-fsize: reduce scope of variable offset
  * stress-pci: reduce scope of i and n_devs
  * stress-landlock: reduce scope of ruleset_fd
  * stress-cgroup: reduce scope of array values and make it static const
  * stress-cache: reduce scope of some variables
  * stress-munmap: add sscanf string size limit to avoid potential buffer
    overflows
  * core-thermal-zone: use PRIu32 format specifier for uint32_t type
  * core-madvise: add sscanf string size limit to avoid potential buffer
    overflows
  * stress-chroot: just report chroot escapes with instance 0
  * stress-ng: make stress_pid_t state flag 8 bits
  * stress-kvm: add early /dev/kvm open permission checking
  * stress-fractal: report co-ordinates as (xmin, ymin) .. (xmax, ymax)
  * stress-ng: comment the stress_pid_t helper functions
  * stress-ng: add atomic load/store helpers for stress_pid_t state
  * core-shared-heap: increase initial size of shared heap
  * stress-ng: always send a SIGCONT to a waiting process
  * stress-prio-inv: indicate a force killed bogo op-counter state when
    child exits
  * stress-ng: remove stress_sync_start_cont, and remove debug
  * stress-open: don't populate mmap'd fd array, it may not be all used
  * stress-ng: stress_sync_start_cont_list: check against number of pids in
    list
  * stress-ng: stress_sync_start_cont_list: take into account finished
    stressors
  * stress-timerfd: configure timer after sync start has completed
  * stress-ng: remove unused variable waiting
  * stress-ng: add delay while waiting for stressors to start in loop
  * stress-timer: configure timer after sync start has completed
  * stress-itimer: configure timer after sync start has completed
  * stress-munmap: fix incorrect clz where size_t is not long long
  * stress-min-nanosleep: fix incorrect clz where size_t is not long long
  * core-thermal-zone: clean up formatting of multiply tz names
  * stress-goto: reduce optimization level for clang
  * stress-yield: fix build for various non-linux systems
  * stress-pci: move stress_set_pci_dev to support all arches
  * stress-min-nanosleep: provide unknown sched name
  * stress-min-nanosleep: fix build for various non-linux systems
  * core-ops: forgot to commit the io-uring-rand option
  * io-uring: add --io-uring-rand option for randomized io-uring ops
  * stress-io-uring: reduce memory impact for smaller memory systems
  * stress-*: remove trailing whitespaces
  * Add --sync-start option
  * README.md: add 4 more kernel issues found with stress-ng
  * stress-min-nanosleep: report scheduler name
  * stress-cpu: minor code clean-ups
  * README.md: update contributors name list
  * stress-cpu: matrixprod: align matrices
  * stress-cpu: idct: re-factor, move some calculations out of loop
  * stress-cpu: fft: align data and pass as restrict pointers
  * stress-min-nanosleep: use the more optimal log2 function
  * stress-sleep: fix expected C state delay, fix typo for selects message
  * stress-min-nanosleep: report shorted nanosleep measurement
  * stress-min-nanosleep: add check for short nanosleeps
  * README.md: add Sergey Matyukevich to contributors list
  * Manual: add missing --mmapfork-bytes manual option
  * stress-min-nanosleep: add stressor that measures minimum nanosleep
    delay times
  * stress-*: pass the number of stressor instances into the stressor init
    callback
  * core-time: check for CLOCK_REALTIME when using it
  * stress-sleep: use monotonic clock and stress_time_now() clocks for time
    measurement
  * stress-sleep: fix typo "to" -> "took"
  * stress-yield: add --yield-sched scheduler options
  * stress-*: use core-sched.h to define HAVE_SCHED_{GET|SET}_ATTR macros
  * core-sched: define HAVE_SCHED_GETATTR and HAVE_SCHED_SETATTR
  * README.md: add one more research paper that references stress-ng
  * stress-workload: use stress_sched_types for scheduler type information
  * stress-schedpolicy: use stress_sched_types for scheduler type
    information
  * stress-schedmix: use stress_sched_types for scheduler type information
  * core-sched: allow stress_sched_types to be in global scope
  * stress-monte-carlo: print monte-carlo computations as debug
  * stress-ping-sock: add pre-run check and explain why it may fail with
    EPERM
  * stress-ng: report stressor name in munged format, replace _ with -
  * lib: remove build dependency on libgcrypt20
  * stress-workload: make c static since it's used in pthread contexts
  * stress-pci: Add a new --pci-dev option to specify the pci device
  * stress-shellsort: remove empty line
  * stress-pci: use strcmp on dentry name for sort ordering
  * stress-io-uring: use O_DIRECT when it is available on files

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 3 Jul 2024 18:33:42 +0100

stress-ng (0.18.00-1) unstable; urgency=medium

  [Fabrice Fontaine]
  * core-sched.c: fix uclibc-ng build
  * stress-sock.c: fix build without SO_ZEROCOPY

  [Hsieh-Tseng Shen]
  * stress-cache: add stress_cache_bzero() to support cache-based bzero
  * core-asm-riscv.h: support riscv zicboz ext cbo.zero instruction

  [John Kacur]
  * stress-ng: stress-stream: Fix use of uninitialized variable

  [Po-Hsu Lin]
  * core-ops: fix --logmath-ops option
  * core-ops: fix --binderfs-ops option

  [Colin Ian King]
  * stress-mincore: cater for mincore on NULL returning ENOMEM on kfreebsd
    systems
  * stress-vm-segv: only use mprotect if system call is supported
  * stress-mseal: only use madvise if system call is supported


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               libacl1-dev,
               zlib1g-dev,
               libbsd-dev,
               libeigen3-dev,
               libcrypt-dev,
               libjpeg-dev,
               libmpfr-dev,
               libgmp-dev,
               libkeyutils-dev [linux-any],
               libapparmor-dev [linux-any],
               apparmor [linux-any],
               libaio-dev [linux-any],
               libcap-dev [linux-any],
               libsctp-dev [linux-any],
               libipsec-mb-dev [amd64],
               libjudy-dev,
               libatomic1 [linux-any],
               libkmod-dev [linux-any],
               libxxhash-dev,
               libglvnd-dev,
               libgbm-dev [linux-any]
Homepage: https://github.com/ColinIanKing/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.
